package com.agiledeveloper;

import junit.framework.TestCase;

public class MonitorTest extends TestCase
{
    public void testMonitorFileChange()
    {
        // + - we can not unit test the Monitor
        // - - it takes too long, and that is not a good unit test.
        
        AlarmMock alarmMock = new AlarmMock();
        FileSystemChangeMock fileSystemChangeMock = new FileSystemChangeMock();
        FileMonitor m = new FileMonitor(fileSystemChangeMock, alarmMock);

        m.monitor("C:\temp");
        assertFalse(alarmMock.alarmRaised);

        fileSystemChangeMock.fileChanged = true;

        try
        {
            Thread.sleep(1000);
        }
        catch (InterruptedException e)
        {
            e.printStackTrace();
        }

        assertTrue(alarmMock.alarmRaised);
    }

    public static void main(String[] args)
    {
        junit.swingui.TestRunner.run(MonitorTest.class);
    }
}
