package com.agiledeveloper;

public class FileMonitor
{
    private FileSystemChange theFileSystemChange;
    private Alarm theAlarm;

    public FileMonitor(FileSystemChange fileSystemChange, Alarm alarm)
    {
        theFileSystemChange = fileSystemChange;
        theAlarm = alarm;
    }

    public void monitor(String path)
    {
        //theFileSystemChange.lookForChange(path);
        startMonitoringFile(path);

        Thread th = new Thread(new Runnable()
        {
            public void run()
            {
                while (true)
                {
//                    if (theFileSystemChange.hasChanged())
//                    {
//                        theAlarm.raise();
//                    }

                    raiseAlarmOnChange();

                    try
                    {
                        Thread.sleep(1000);
                    }
                    catch (InterruptedException e)
                    {
                        e.printStackTrace();
                    }
                }
            }
        }
        );

        th.setDaemon(true);
        th.start();
    }

    void raiseAlarmOnChange()
    {
        if (theFileSystemChange.hasChanged())
        {
            theAlarm.raise();
        }
    }

    void startMonitoringFile(String path)
    {
        theFileSystemChange.lookForChange(path);
    }
}
